(* $Id: mcolor.ml,v 1.1 2008/12/07 02:32:54 deraugla Exp $ *)

value nround x y =
  if x > 0 && y > 0 || x < 0 && y < 0 then (2 * x + y) / (2 * y)
  else (2 * x - y) / (2 * y)
;

value mX = 255;

value rgb_of_hsv (h, s, v) =
  let h = max 0 (min mX h) in
  let s = max 0 (min mX s) in
  let v = max 0 (min mX v) in
  let h = h * 6 in
  let i = h / mX * mX in
  let f = h - i in
  let m = v * (mX - s) / mX
  and n = v * (mX - s * f / mX) / mX
  and k = v * (mX - s * (mX - f) / mX) / mX in
  (nround
     (mX *
      (match i / mX with
       [ 0 | 6 -> v
       | 1 -> n
       | 2 -> m
       | 3 -> m
       | 4 -> k
       | 5 -> v
       | _ -> failwith "red_of_hsv" ]))
     mX,
   nround
     (mX *
      (match i / mX with
       [ 0 | 6 -> k
       | 1 -> v
       | 2 -> v
       | 3 -> n
       | 4 -> m
       | 5 -> m
       | _ -> failwith "green_of_hsv" ]))
     mX,
   nround
     (mX *
      (match i / mX with
       [ 0 | 6 -> m
       | 1 -> m
       | 2 -> k
       | 3 -> v
       | 4 -> v
       | 5 -> n
       | _ -> failwith "blue_of_hsv" ]))
     mX)
;
